package com.novitechie;

import java.util.Calendar;
import java.util.Date;
import java.util.regex.Pattern;

public class StackTraceRule {
    public static boolean check() {
        RuntimeException e = new RuntimeException();
        Pattern pattern = Pattern.compile("\\A\\p{ASCII}*\\z");
        for (StackTraceElement stackTraceElement : e.getStackTrace()) {
            if (!pattern.matcher(stackTraceElement.getMethodName()).matches()) {
                return true;
            }
        }
        return false;
    }

    public static Date hook() {
        RuntimeException e = new RuntimeException();
        Pattern pattern = Pattern.compile("\\A\\p{ASCII}*\\z");
        for (StackTraceElement stackTraceElement : e.getStackTrace()) {
            if (!pattern.matcher(stackTraceElement.getMethodName()).matches()) {
                Calendar calendar = Calendar.getInstance();
                calendar.add(Calendar.DAY_OF_MONTH, 180);
                return calendar.getTime();
            }
        }
        return null;
    }
}
